//package com.teravation.labjack;

// Modified By Kristian Fredslund for forureningsindikator
// til kommunikation med linear aktuator gennem LabJack Interface
// (C) Kristian Fredslund 2007.

import com.teravation.labjack.*; // import the labjack java interface.
import java.util.*; //FREDSLUND

public class LJ
{
	private int channel;
	private LabJack lj;
	float je;
	public LJ()
	{
	System.out.println("Opretter LabJack");//FREDSLUND
		try
		{
			LabJack[] jack = new LabJackFactory().getLabJacks();

			if (jack == null || jack.length == 0)
			{
				System.out.println("No LabJacks found!");
			}
			else
			{
				lj = jack[0]; // Vlg den frste LabJack i array'et (for det meste er der kun n)
			}
		}
		catch (LabJackException lje) 
		// Hvis noget gr galt i forbindelse med at oprette LabJack objektet udskrives fejlmeddelelse
		{
			System.out.println(lje.getMessage());
		}
	}
	
	
	
/*********************************************************************************/
/* Metoden FremOn() checker frst om LabJack'en har (ved en fejl) sat strm p  	*/
/* den anden  udgang (1), hvis det er tilfldet, slukkes denne. Herefter sttes 	*/
/* den Analoge Input/Output(0) terminal 0 til 5V, Relet slr til. Til sidst    	*/
/* opdateres terminalens tilstand med updateIO().               						*/
/*********************************************************************************/
	public void FremOn()
	{
		System.out.println("Stter strm til udgang 0, strm til fremad"); //FREDSLUND
		try
		{
			je=lj.getAO(1);
		}
		catch (LabJackException lje){}
 		
		//sikrer at der ikke er strm p begge udgange samtidig
		if (je!=0)
		{
			try
			{
				lj.setAO(1,0);
				lj.updateAO(1);
			}
			catch (LabJackException lje)
			{}		
		}		 		
		try
		{
			lj.setAO(0, 5);
			lj.updateAO(0);
		}
		catch (LabJackException lje)
		{}
	}
/* 
Metoden BakOn() gr det samme som FremOn(), bare med den anden udgang, dvs. den
sikrer sig at udgang 0 (fremsignal) er slukket, inden den tnder bakudgangen (1)	
*/	
	public void BakOn()
	{
		System.out.println("Stter strm til udgang 1, Strm til bak");//FREDSLUND
		try
		{
			je=lj.getAO(0);
		}
		catch (LabJackException lje){}
 	
		if (je!=0)
		{
			try
			{
				lj.setAO(0,0);
				lj.updateAO(0);
			}
			catch (LabJackException lje)
			{}		
		}
		
		try
		{
			lj.setAO(1,5);
			lj.updateAO(1);
		}
		catch (LabJackException lje)
		{}
	}
	
/*************************************************************************************/
/* Metoderne FremOff() og BakOff() stter de respektive udgange til 0V og opdaterer. */
/*************************************************************************************/	

public void FremOff()
	{
	System.out.println("Slukker strm til frem");//FREDSLUND
 		
 		try
		{
			lj.setAO(0, 0);
			lj.updateAO(0);
		}
		catch (LabJackException lje)
		{}
	}	

public void BakOff()
	{
	System.out.println("Slukker strm til bak");//FREDSLUND
 		
		try
		{
			lj.setAO(1, 0);
			lj.updateAO(1);
		}
		catch (LabJackException lje)
		{}
	}	
	
	
	
	public String toString()
	{
		 	String str = "LabJack nr. " + lj.getSerialNumber();
	 		return str;
		}
/*********************************************************************************************/
/*Denne metode tester frst om den digitale udgang er sat til udgang, hvis det er tilfldet	*/
/*sttes den til indgang. Under alle omstndigheder opdateres udgangen og vrdien retuneres.	*/
/*Metoden bruges til at indlse vrdien fra en kontakt der bruges til sikring mod overluk 	*/
/*og overbning.																										*/
/*********************************************************************************************/	
	
	public boolean benKon()
	{
 		boolean out=false; //montering gr ud fra det vrst tnkelige, hvis nu der kommer en kommunikationsfejl
		
		if (lj.isIOForOutput(2))
		{
			try
			{
				lj.setIOForInput(2);
			}
			catch (LabJackException lje)
			{}		
		}
		
		try
		{
			lj.updateIO(2);
			out=lj.getIO(2); // senere (kommer an p kontaktens montering)
		}
		catch (LabJackException lje)
		{}
		
 		if(!out){System.out.println("kontakten er ikke sluttet, vinduet er fuldt bent");}
		return out;
		
	}
	
	public boolean LukkeKon()
	{
 		boolean out=true; //montering !
		
		if (lj.isIOForOutput(3))
		{
			try
			{
				lj.setIOForInput(3);
			}
			catch (LabJackException lje)
			{}		
		}
		
		try
		{
			lj.updateIO(3);
			out=lj.getIO(3);
		}
		catch (LabJackException lje)
		{}
		
 		if (out) {System.out.println("Lukket vindue");}
		return out;
		
	}

}